/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-industrial-msgs-0.3.4-1precise-20150327-1811/msg/DebugLevel.msg
 *
 */


#ifndef INDUSTRIAL_MSGS_MESSAGE_DEBUGLEVEL_H
#define INDUSTRIAL_MSGS_MESSAGE_DEBUGLEVEL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace industrial_msgs
{
template <class ContainerAllocator>
struct DebugLevel_
{
  typedef DebugLevel_<ContainerAllocator> Type;

  DebugLevel_()
    : val(0)  {
    }
  DebugLevel_(const ContainerAllocator& _alloc)
    : val(0)  {
    }



   typedef uint8_t _val_type;
  _val_type val;


    enum { DEBUG = 5 };
     enum { INFO = 4 };
     enum { WARN = 3 };
     enum { ERROR = 2 };
     enum { FATAL = 1 };
     enum { NONE = 0 };
 

  typedef boost::shared_ptr< ::industrial_msgs::DebugLevel_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::industrial_msgs::DebugLevel_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct DebugLevel_

typedef ::industrial_msgs::DebugLevel_<std::allocator<void> > DebugLevel;

typedef boost::shared_ptr< ::industrial_msgs::DebugLevel > DebugLevelPtr;
typedef boost::shared_ptr< ::industrial_msgs::DebugLevel const> DebugLevelConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::industrial_msgs::DebugLevel_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::industrial_msgs::DebugLevel_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace industrial_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'industrial_msgs': ['/tmp/buildd/ros-hydro-industrial-msgs-0.3.4-1precise-20150327-1811/msg'], 'trajectory_msgs': ['/opt/ros/hydro/share/trajectory_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::industrial_msgs::DebugLevel_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::industrial_msgs::DebugLevel_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::industrial_msgs::DebugLevel_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
{
  static const char* value()
  {
    return "5bfde194fd95d83abdb02a03ee48fbe7";
  }

  static const char* value(const ::industrial_msgs::DebugLevel_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x5bfde194fd95d83aULL;
  static const uint64_t static_value2 = 0xbdb02a03ee48fbe7ULL;
};

template<class ContainerAllocator>
struct DataType< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
{
  static const char* value()
  {
    return "industrial_msgs/DebugLevel";
  }

  static const char* value(const ::industrial_msgs::DebugLevel_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Debug level message enumeration.  This may replicate some functionality that\n\
# alreay exists in the ROS logger.\n\
# TODO: Get more information on the ROS Logger.\n\
uint8 val\n\
\n\
uint8 DEBUG = 5\n\
uint8 INFO = 4\n\
uint8 WARN = 3\n\
uint8 ERROR = 2\n\
uint8 FATAL = 1\n\
uint8 NONE = 0 \n\
";
  }

  static const char* value(const ::industrial_msgs::DebugLevel_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.val);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct DebugLevel_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::industrial_msgs::DebugLevel_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::industrial_msgs::DebugLevel_<ContainerAllocator>& v)
  {
    s << indent << "val: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.val);
  }
};

} // namespace message_operations
} // namespace ros

#endif // INDUSTRIAL_MSGS_MESSAGE_DEBUGLEVEL_H
